<?php

/**
 * co_documento_ep actions.
 *
 * @package    contratacion
 * @subpackage co_documento_ep
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_documento_epActions extends sfQuery
{
    /*
    * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
    */
    protected $table_names = array(
        'CO_DOCUMENTO_EP','CO_ESTUDIOS_PREVIOS', 'CO_DOCUM_MODALIDAD', 'CO_MODALIDAD_SEL', 'CO_TIPO_DOCUMENTO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CO_ESTUDIOS_PREVIOS' =>
        array(
            'id_estudios_previos' => 'CO_DOCUMENTO_EP'
        ),
        'CO_DOCUM_MODALIDAD' =>
        array(
            'id_docum_modalidad' => 'CO_DOCUMENTO_EP'
        ),
        'CO_MODALIDAD_SEL' =>
        array(
            'id_modalidad_sel' => 'CO_DOCUM_MODALIDAD'
        ),
        'CO_TIPO_DOCUMENTO' =>
        array(
            'id_tipo_documento' => 'CO_DOCUM_MODALIDAD'
        ),
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
       'CO_DOCUMENTO_EP' =>
       array(
            'id_documento_ep' => 'id_documento_ep',
            'id_estudios_previos' => 'id_estudios_previos',
            'id_docum_modalidad' => 'id_docum_modalidad',
            'fecha_registro' => 'fecha_registro',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto',
            'aprobado' => 'aprobado',
            'fecha_aprobado' => 'fecha_aprobado',
            'id_usuario_aprobado' => 'id_usuario_aprobado'
        ),
        'CO_DOCUM_MODALIDAD' =>
        array(
            'id_tipo_documento' => 'id_tipo_documento',
            'estado' => 'estado'
        ),
        'CO_MODALIDAD_SEL' =>
        array(
            'id_modalidad_sel' => 'id_modalidad_sel',
            'descripcion' => 'descripcion_modalidad'
        ),
        'CO_ESTUDIOS_PREVIOS' =>
        array(
            'no_proceso' => 'no_proceso',
            'fecha_creacion' => 'fecha_creacion'
        ),
        'CO_TIPO_DOCUMENTO' => 
        array(
            'descripcion' => 'descripcion_documento'
        )
           
        
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
       'CO_DOCUMENTO_EP' =>
        array(    
            'id_documento_ep,a' => array('!=' => array(-1)),
            'id_documento_ep,b' => array('=' => array('id_documento_ep')),
            'id_estudios_previos,b' => array('=' => array('id_estudios_previos')),
            'id_docum_modalidad,b' => array('=' => array('id_docum_modalidad')),
            'estado' => array('=' => array('estado')),
            'aprobado' => array('=' => array('aprobado')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CO_MODALIDAD_SEL' =>
        array(
            'id_modalidad_sel' => array('=' => array('id_modalidad_sel')),
            
        ),
        'CO_TIPO_DOCUMENTO' => 
        array(
            'id_tipo_documento' => array('=' => array('id_tipo_documento')),
        ),
        'CO_ESTUDIOS_PREVIOS' => 
        array(
            'no_proceso' => array('=' => array('no_proceso')),
            'id_anhos' => array('=' => array('id_anhos'))
        )
        
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_documento_ep'; //identificador de la tabla
    protected $id_names = array('id_documento_ep'); //llave primaria
    protected $field_names = array('id_estudios_previos', 'id_docum_modalidad','fecha_registro','observaciones','adjunto'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CO_DOCUMENTO_EP'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_documento_ep'; //identificador unico de la tabla
    
    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
            
            
            
            
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
         //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    } 
}
